namespace Syntriax.Engine.Core.Abstract;

/// <summary>
/// Represents a basic entity in the engine.
/// </summary>
public interface IEntity : IInitialize, IAssignableStateEnable
{
    /// <summary>
    /// Event triggered when the <see cref="Id"/> of the <see cref="IEntity"/> changes.
    /// The string action parameter is the previous <see cref="Id"/> of the <see cref="IEntity"/>. 
    /// </summary>
    event OnIdChangedDelegate? OnIdChanged;

    /// <summary>
    /// The ID of the <see cref="IEntity"/>.
    /// </summary>
    string Id { get; set; }

    delegate void OnIdChangedDelegate(IEntity sender, string previousId);
}
